/*
 * um in main.c einfach mehr Uebersicht zu haben, hier eine Quick & Dirty-
 * Sammlung von typisch anfallendem Zeug: libc-Initialisierung, langweilige
 * Standard-Routinen, usw.
 *
 ** ANALEX-INTERFACE, kopiert von Gamma10-Interface am
 ** 28. August 2010, 17:30 im Museum
 *
 */

#define  __AVR_ATmega644__   1
//#define  OSCSPEED            20*1000*1000
// statt OSCSPEED hab ich jetzt auch F_CPU genutzt in UartInit()
// F_CPU wird durch die make file (den Aufruf von AVR Studio) bereits definiert

#include <string.h>
#include <stdio.h>
#include <stdlib.h> // abs, itoa
#include <stdint.h> // int8_t, uint16_t
typedef unsigned char byte_t;

#include <util/delay.h>

#include "avr/io.h"
#include "avr/interrupt.h"

// STDIO aufsetzen

static int uart_transmit(char c, FILE *stream) {
	if (c == '\n')
		uart_transmit('\r', stream);
	loop_until_bit_is_set(UCSR0A, UDRE0);
	UDR0 = c;
	return 0;
}

static FILE _meine_stdout_ = FDEV_SETUP_STREAM(uart_transmit, NULL, _FDEV_SETUP_WRITE);

// das muss im main() aufgerufen werden:
#define setup_stdio()  ( stdout = &_meine_stdout_ )


// LED-Spielzeug
// sic! mit ja/nein und so
#define stop_led()		( PORTB &= ~(1 << PORTB0) )
#define start_led()		( PORTB |= (1 << PORTB0) )
#define is_led()        ( PINB & (1 << PORTB0) )
#define toggle_led()    ( is_led() ? stop_led() : start_led() )


void UartInit(uint32_t Baud)
{
        int BaudRate = F_CPU / (16 * Baud) - 1;

        UBRR0H = (unsigned char) BaudRate>>8;
        UBRR0L = (unsigned char) BaudRate;
        //set BaudRate

        UCSR0B = UCSR0B | (0b00011000);
        // RXEN & TXEN enable (Bits 4, 3 = 1)

        UCSR0C = (UCSR0C | (0b10000110));
        // USART Register Select (Bit 7 = 1)
        // 8 data bits per frame (Bit 2, 1 = 1)

        UCSR0C = UCSR0C & 0b11110111;
        // 1 Stop bit (Bit 3 = 0)      
}


void print_bits(byte_t byte) {
	char str[10];
	/*
	byte_t bit; byte_t pos = 0;
	for(bit = 7; bit >= 0; bit--) {
		str[pos++] = ( (1 << bit) & byte ) ? '1' : '0';
	}
	str[8] = ' ';
	str[9] = '\0';
	puts(str);
	*/
	puts(itoa(byte, str, 2));
}
