#include "frontend.h"
#include "anelex.h"

void readline() {
	int position;
	memset(&current_line, 0, LINE_LENGTH);
	start_cts();

	// loop for first user input
	for(;;) {
		if(has_character())
			break;
		else if(is_button()) {
			// wait for button press finished
			while(is_button());
			strcpy(current_line, "?print 1");
			puts("Button pressed.");
			stop_cts();
			return;
		} else if(line_state == LINE_FINISHED) {
			// LINE_PRINTING-Phase ist vorbei, Zeile ist jetzt fertig.
			// Aber wir warten immer noch auf User Interaction...
			// puts("Printer is ready for new cycle, but you haven't even started typing.");
		}
	}

	// read in the line
	for(position=0; position < LINE_LENGTH; position++) {
		char* c = &current_line[position]; // shortcut
		
		// wait for a character at UART
		while( !has_character() );

		// got a character
		*c = UDR0;
		
		// check the recieved character for line ending
		if(*c == '\n' || *c == '\r')
			break;
	}
	
	stop_cts();
	current_line[position+1] = '\0';

	// terminal echo:
	puts(current_line);   // 	printf("%d: %s\n", strlen(buffer), buffer);

	// done.
	return;
}

bool_t exec_command() {
	char* command = current_line + 1;
	printf("Executing command %s\n", command);

	if(strcasecmp(command, "help") >= 0) {
	} else {
		puts("! Command not understood. Please type ?help");
	}

	return 0;
}

int uart_transmit(char c, FILE *stream) {
	if (c == '\n')
		uart_transmit('\r', stream);
	loop_until_bit_is_set(UCSR0A, UDRE0);
	UDR0 = c;
	return 0;
}

void uart_init(uint32_t Baud) {
    int BaudRate = F_CPU / (16 * Baud) - 1;

    UBRR0H = (unsigned char) BaudRate>>8;
    UBRR0L = (unsigned char) BaudRate;
    //set BaudRate

    UCSR0B = UCSR0B | (0b00011000);
    // RXEN & TXEN enable (Bits 4, 3 = 1)

    UCSR0C = (UCSR0C | (0b10000110));
    // USART Register Select (Bit 7 = 1)
    // 8 data bits per frame (Bit 2, 1 = 1)

    UCSR0C = UCSR0C & 0b11110111;
    // 1 Stop bit (Bit 3 = 0)      
}


void print_bits(byte_t byte) {
	char str[10];
	puts(itoa(byte, str, 2));
}
